
-------------------------------------------------------------------------------
-- Optimization
-------------------------------------------------------------------------------

-- GLOBALS: ChatFrame_AddMessageEventFilter, ChatFrame_RemoveMessageEventFilter, next

-------------------------------------------------------------------------------
-- Namespace
-------------------------------------------------------------------------------

local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database
local L
local M = A:NewModule("Automation Watch")

local EVENTS_WITH_FACTION = {
	"CHAT_MSG_COMBAT_FACTION_CHANGE",
}

-------------------------------------------------------------------------------
-- Helpers
-------------------------------------------------------------------------------

local function WatchFaction(self, event, message, ...)
	local faction = L:ParseFactionName(message)

	if faction then
		L:SetWatchedFactionName(faction, true)
	end

	return false, message, ...
end

-------------------------------------------------------------------------------
-- Module
-------------------------------------------------------------------------------

function M:OnInitialize()
	L = A:GetModule("Chat Link")
end

function M:OnEnable()
	self:AddMessageEventFilters()
end

function M:OnDisable()
	self:RemoveMessageEventFilters()
end

-- Add a message event filter for each event.
function M:AddMessageEventFilters()
	for _, event in next, EVENTS_WITH_FACTION do
		ChatFrame_AddMessageEventFilter(event, WatchFaction)
	end
end

-- Remove all message event filters.
function M:RemoveMessageEventFilters()
	for _, event in next, EVENTS_WITH_FACTION do
		ChatFrame_RemoveMessageEventFilter(event, WatchFaction)
	end
end
